/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
	"fmt"
)

// StartTrigger the model 'StartTrigger'
type StartTrigger string

// List of StartTrigger
const (
	TRIGGER_ONLY StartTrigger = "trigger_only"
	OPT_OUT StartTrigger = "opt_out"
	MESSAGE StartTrigger = "message"
)

// All allowed values of StartTrigger enum
var AllowedStartTriggerEnumValues = []StartTrigger{
	"trigger_only",
	"opt_out",
	"message",
}

func (v *StartTrigger) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := StartTrigger(value)
	for _, existing := range AllowedStartTriggerEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid StartTrigger", value)
}

// NewStartTriggerFromValue returns a pointer to a valid StartTrigger
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewStartTriggerFromValue(v string) (*StartTrigger, error) {
	ev := StartTrigger(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for StartTrigger: valid values are %v", v, AllowedStartTriggerEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v StartTrigger) IsValid() bool {
	for _, existing := range AllowedStartTriggerEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to StartTrigger value
func (v StartTrigger) Ptr() *StartTrigger {
	return &v
}

type NullableStartTrigger struct {
	value *StartTrigger
	isSet bool
}

func (v NullableStartTrigger) Get() *StartTrigger {
	return v.value
}

func (v *NullableStartTrigger) Set(val *StartTrigger) {
	v.value = val
	v.isSet = true
}

func (v NullableStartTrigger) IsSet() bool {
	return v.isSet
}

func (v *NullableStartTrigger) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableStartTrigger(val *StartTrigger) *NullableStartTrigger {
	return &NullableStartTrigger{value: val, isSet: true}
}

func (v NullableStartTrigger) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableStartTrigger) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

